#!/usr/bin/perl

$timeout_return=0;
$use_uniq_jobs=0;

$from_file="/etc/mod_gearman/mod_gearman_worker.conf";
$to_file="/etc/mod_gearman/mod_gearman_worker.conf";

# Check if option exists
if ( -e $from_file ) {
	open(FILE, "<",$from_file);
	@lines=<FILE>;
	close(FILE);
	foreach (@lines) {
		$line=$_;
		@parts=split(/[ =]+/, $line);
		if ($#parts>0) {
			if ($parts[0] eq "timeout_return") {
				# option already in conf exits
				$timeout_return=1;
			}
		}
	}
}

$#newfile=-1;
$found=0;
open(FILE, "<",$to_file);
@lines=<FILE>;
close(FILE);
foreach (@lines) {
	$line=$_;
	@parts=split(/[ =]+/, $line);
	if ($#parts>0) {
		if ($parts[0] eq "show_error_output") {
			if ($found==0) {
				push(@newfile, $line);
				if ($timeout_return==0) {
					push(@newfile, "\n");
					push(@newfile, "# timeout_return defines the return code for timed out checks. Accepted return\n");
					push(@newfile, "# codes are 0 (Ok), 1 (Warning), 2 (Critical) and 3 (Unknown) Default: 2\n");
					push(@newfile, "timeout_return=3\n");
				}
				$found=1;
			}
			next;
		}
	}
	push(@newfile, $line);
}
open FILE, ">", "$to_file";
print FILE @newfile;
close(FILE);


$from_file="/etc/mod_gearman/mod_gearman_neb.conf";
$to_file="/etc/mod_gearman/mod_gearman_neb.conf";

# Check if option exists
if ( -e $from_file ) {
	open(FILE, "<",$from_file);
	@lines=<FILE>;
	close(FILE);
	foreach (@lines) {
		$line=$_;
		@parts=split(/[ =]+/, $line);
		if ($#parts>0) {
			if ($parts[0] eq "use_uniq_jobs") {
				# option already in conf exits
				$use_uniq_jobs=1;
			}
		}
	}
}

$#newfile=-1;
$found=0;
open(FILE, "<",$to_file);
@lines=<FILE>;
close(FILE);
foreach (@lines) {
	$line=$_;
	@parts=split(/[ =]+/, $line);
	if ($#parts>0) {
		if ($parts[0] eq "#keyfile") {
			if ($found==0) {
				push(@newfile, $line);
				if ($use_uniq_jobs==0) {
					push(@newfile, "\n");
					push(@newfile, "# Using uniq keys prevents the gearman queues from filling up when there\n");
					push(@newfile, "# is no worker. However, gearmand seems to have problems with the uniq\n");
					push(@newfile, "# key and sometimes jobs get stuck in the queue. Set this option to 'off'\n");
					push(@newfile, "# when you run into problems with stuck jobs but make sure your worker\n");
					push(@newfile, "# are running.\n");
					push(@newfile, "use_uniq_jobs=off\n");
				}
				$found=1;
			}
			next;
		}
	}
	push(@newfile, $line);
}
open FILE, ">", "$to_file";
print FILE @newfile;
close(FILE);


# route_eventhandler_like_checks=no
$from_file="/etc/mod_gearman/mod_gearman_neb.conf";
$to_file="/etc/mod_gearman/mod_gearman_neb.conf";
$option_exists = 0;
# Check if option exists
if ( -e $from_file ) {
	open(FILE, "<",$from_file);
	@lines=<FILE>;
	close(FILE);
	foreach (@lines) {
		$line=$_;
		@parts=split(/[ =]+/, $line);
		if ($#parts>0) {
			if ($parts[0] eq "route_eventhandler_like_checks") {
				# option already in conf exits
				$option_exists=1;
			}
		}
	}
}
else {
	$option_exists=1;
}
if ($option_exists==0) {
	open(FILE, ">>",$to_file);
	print FILE "\n";
	print FILE "# This settings determines if all eventhandlers go into a single\n";
	print FILE "# 'eventhandlers' queue or into the same queue like normal checks\n";
	print FILE "# would do.\n";
	print FILE "route_eventhandler_like_checks=no\n";
	close(FILE);
}

# orphan_return=2
$from_file="/etc/mod_gearman/mod_gearman_neb.conf";
$to_file="/etc/mod_gearman/mod_gearman_neb.conf";
$option_exists = 0;
# Check if option exists
if ( -e $from_file ) {
	open(FILE, "<",$from_file);
	@lines=<FILE>;
	close(FILE);
	foreach (@lines) {
		$line=$_;
		if ($line =~ /orphan_return/) {
			# option already in conf exits
			$option_exists=1;
		}
	}
}
else {
	$option_exists=1;
}
if ($option_exists==0) {
	open(FILE, ">>",$to_file);
	print FILE "\n";
	print FILE "# set return code of orphaned checks\n";
	print FILE "# orphan_return=2\n";
	close(FILE);
}

exit(0);
